---
title: Element.setPointerCapture()
slug: Web/API/Element/setPointerCapture
tags:
  - API
  - DOM
  - Element
  - Method
  - PointerEvent
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>setPointerCapture()</code></strong> method of the {{domxref("Element")}} interface is used to designate a specific element as the <em>capture target</em> of future pointer events. Subsequent events for the pointer will be targeted at the capture element until capture is released (via {{domxref("Element.releasePointerCapture()")}}).</p>

<div class="note"><strong>Note:</strong> When pointer capture is set, {{domxref("HTMLElement/pointerover_event", "pointerover")}}, {{domxref("HTMLElement/pointerout_event", "pointerout")}}, {{domxref("HTMLElement/pointerenter_event", "pointerenter")}}, and {{domxref("HTMLElement/pointerleave_event", "pointerleave")}} events are only generated when crossing the boundary of the capture target. This has the effect of suppressing these events on all other elements.</div>

<h3 id="Overview_of_pointer_capture">Overview of pointer capture</h3>

<p><em>Pointer capture</em> allows events for a particular <em>pointer event</em> ({{domxref("PointerEvent")}}) to be re-targeted to a particular element instead of the normal (or <em>hit test</em>) target at a pointer's location. This can be used to ensure that an element continues to receive pointer events even if the pointer device's contact moves off the element (such as by scrolling or panning).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>targetElement</var>.setPointerCapture(<var>pointerId</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>pointerId</var></code></dt>
 <dd>The {{domxref("PointerEvent.pointerId", "pointerId")}} of a {{domxref("PointerEvent")}} object.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>This method returns {{jsxref("undefined")}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>NotFoundError</code></td>
   <td><code><var>pointerId</var></code> does not match any of the active pointers.
    <div class="note"><strong>Note:</strong> Firefox versions <em>before</em> Firefox 82 incorrectly throw <code>InvalidPointerId</code>.</div>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>This example sets pointer capture on a {{HtmlElement("div")}} when you press down on it. This lets you slide the element horizontally, even when you pointer moves outside of its boundaries.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div id="slider"&gt;SLIDE ME&lt;/div&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">div {
  width: 140px;
  height: 50px;
  display: flex;
  align-items: center;
  justify-content: center;
  background: #fbe;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">function beginSliding(e) {
  slider.onpointermove = slide;
  slider.setPointerCapture(e.pointerId);
}

function stopSliding(e) {
  slider.onpointermove = null;
  slider.releasePointerCapture(e.pointerId);
}

function slide(e) {
  slider.style.transform = `translate(${e.clientX - 70}px)`;
}

const slider = document.getElementById('slider');

slider.onpointerdown = beginSliding;
slider.onpointerup = stopSliding;
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Pointer Events 2','#dom-element-setpointercapture', 'setPointerCapture')}}</td>
   <td>{{Spec2('Pointer Events 2')}}</td>
   <td>Non-stable version.</td>
  </tr>
  <tr>
   <td>{{SpecName('Pointer Events', '#widl-Element-setPointerCapture-void-long-pointerId', 'setPointerCapture')}}</td>
   <td>{{Spec2('Pointer Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.setPointerCapture")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Element.releasePointerCapture")}}</li>
 <li>{{domxref("Pointer_events","Pointer Events")}}</li>
</ul>
